
/*************************************************************
*                                                            *
*       CGI C++ Library v0.29a                               *
*                                                            *
*       (c) 2005-2007 by Ighor Poteryakhin (ighor@ighor.ru)  *
*                                                            *
*       basic.h                                              *
*                                                            *
*************************************************************/

#include "basic.h"

using namespace std;
using namespace consts;

namespace cgi
{

    void basic::move(void *from, void *to, int count)
    {
        char *sfrom=(char*) from;
        char *sto=(char*) to;
        for(int i=0;i<count;i++)
        {
    	sto[i]=sfrom[i];
        }
    }

    char* basic::itoa(int num, char *to)
    {
        sprintf(to,"%d",num);
        return to;
    }
    
    char* basic::itoa(int num)
    {
        static char to[255];
        itoa(num,to);
        return to;
    }

    char* basic::itoh(int num, char *to)
    {
        sprintf(to,"%h",num);
        return to;
    }
    
    char* basic::itoh(int num)
    {
        static char to[255];
        itoh(num,to);
        return to;
    }
    
    char* basic::hitoa(unsigned char num, char *to)
    {
        sprintf(to,"%X",num);
        return to;
    }
    
    char* basic::hitoa(unsigned char num)
    {
        static char to[255];
        hitoa(num,to);
        return to;
    }
    
    int basic::count_sym(const char *s,const char c)
    {
        int count=0;
        for(unsigned int i=0;i<=strlen(s);i++)
    	if(s[i]==c)
    	    count++;
        return count;
    }
    
    std::string basic::win1251_2_koi8ru(std::string ins)
    {
        if(iconv_max_length<=ins.length())
    	throw "Internal Error: text to convert is too long";
        size_t len=ins.length();
        char *from=(char *)ins.c_str();
        char to[iconv_max_length]; //!!!
        char *res=to;
        iconv_t iconv_mode=iconv_open("KOI8-R//IGNORE","CP1251");
        if( iconv_mode == (iconv_t)(-1) )
    	throw( "Error converting from one charset to other, iconv_open() failed!" );
        to[len]='\0';
        iconv(iconv_mode,&from,&len,&res,&len);
        iconv_close(iconv_mode);
        std::string outs(to); // to!!!
        return outs;
    }
    
    std::string basic::strip(std::string s)
    {
	while(s[0]=='\'')
	    s.erase(0,1);

	while(s[s.length()-1]=='\'')
	    s.erase(s.length()-1,1);

	return s;
    }

    std::string basic::trim(std::string s)
    {
	while(s[0]==' '||s[0]=='\t')
	    s.erase(0,1);

	while(s[s.length()-1]==' '||s[s.length()-1]=='\t')
	    s.erase(s.length()-1,1);

	return s;
    }

    std::string basic::safe(const std::string& s)
    {
	std::string res;
	for(int i=0;i<s.length();++i)
	    if(s[i]>='A'&&s[i]<='Z'||s[i]>='a'&&s[i]<='z'||s[i]>='0'&&s[i]<='9'||s[i]==' ')
		res+=s[i];
	    else
		res+='*';
	return res;
    }

    std::string basic::detag(const std::string &s)
    {
	string res=string("");
	for(unsigned i=0;i<s.length();++i)
    	    if(s[i]=='<')
        	res+="&lt ";
    	    else if(s[i]=='\"')
		res+="&quotes ";
	    else
        	res+=s[i];
	return res;
    }
    std::string basic::_gettime(time_t t)
    {
        string res;
        string tt;
        //must be Wdy, DD-Mon-YYYY HH:MM:SS GMT
        struct tm *tm_res;
        tm_res=gmtime(&t);
        switch(tm_res->tm_wday)
        {
            case 0:
                res+="Sun";
                break;
            case 1:
                res+="Mon";
                break;
            case 2:
                res+="Tue";
                break;
            case 3:
                res+="Wed";
                break;
            case 4:
                res+="Thu";
                break;
            case 5:
                res+="Fri";
                break;
            case 6:
                res+="Sat";
                break;
            default:
                throw "Internal error: cgi_app::_gettime(): Day num>6!";
        }
        res+=", ";
        tt=itoa(tm_res->tm_mday);
        if(tt.length()==1)
            tt="0"+tt;
        res+=tt;
        res+="-";
        switch(tm_res->tm_mon)
        {
            case 0:
                res+="Jan";
                break;
            case 1:
                res+="Feb";
                break;
            case 2:
                res+="Mar";
                break;
            case 3:
                res+="Apr";
                break;
            case 4:
                res+="May";
                break;
            case 5:
                res+="Jun";
                break;
            case 6:
                res+="Jul";
                break;
            case 7:
                res+="Aug";
                break;
            case 8:
                res+="Sep";
                break;
            case 9:
                res+="Oct";
                break;
            case 10:
                res+="Nov";
                break;
            case 11:
                res+="Dec";
                break;
            default:
                throw "Internal error: cgi_app::_gettime(): Month num>11!";
        }
        res+="-";
        tt=itoa(tm_res->tm_year+1900);
        res+=tt;
        res+=" ";
        tt=itoa(tm_res->tm_hour);
        if(tt.length()==1)
            tt="0"+tt;
        res+=tt;
        res+=":";
        tt=itoa(tm_res->tm_min);
        if(tt.length()==1)
            tt="0"+tt;
        res+=tt;
        res+=":";
        tt=itoa(tm_res->tm_sec);
        if(tt.length()==1)
            tt="0"+tt;
        res+=tt;
        res+=" GMT";

        return res;
    }

    std::string basic::_gettimem(time_t t)
    {
        string res=_gettime(t);
	for(register unsigned i=0;i<res.length();++i)
	    if(res[i]=='-')
		res[i]=' '; // 0x20 - space
	return res;
    }
    

    // taken from here http://www.adp-gmbh.ch/cpp/common/base64.html - there was no copyrights ?

    inline bool basic::is_base64(unsigned char c)
    {
	 return (isalnum(c) || (c == '+') || (c == '/'));
    }

    std::string basic::base64_encode(unsigned char const* bytes_to_encode, unsigned int in_len)
    {
	std::string ret;
	int i = 0;
	int j = 0;
	unsigned char char_array_3[3];
	unsigned char char_array_4[4];

	while (in_len--) 
	{
	    char_array_3[i++] = *(bytes_to_encode++);
	    if (i == 3) 
	    {
    		char_array_4[0] = (char_array_3[0] & 0xfc) >> 2;
    		char_array_4[1] = ((char_array_3[0] & 0x03) << 4) + ((char_array_3[1] & 0xf0) >> 4);
    		char_array_4[2] = ((char_array_3[1] & 0x0f) << 2) + ((char_array_3[2] & 0xc0) >> 6);
    		char_array_4[3] = char_array_3[2] & 0x3f;

		for(i = 0; (i <4) ; i++)
		ret += consts::base64_chars[char_array_4[i]];
		i = 0;
	    }
	}

	if (i)
	{
	    for(j = i; j < 3; j++)
		char_array_3[j] = '\0';

	    char_array_4[0] = (char_array_3[0] & 0xfc) >> 2;
	    char_array_4[1] = ((char_array_3[0] & 0x03) << 4) + ((char_array_3[1] & 0xf0) >> 4);
	    char_array_4[2] = ((char_array_3[1] & 0x0f) << 2) + ((char_array_3[2] & 0xc0) >> 6);
	    char_array_4[3] = char_array_3[2] & 0x3f;

	    for (j = 0; (j < i + 1); j++)
		ret += consts::base64_chars[char_array_4[j]];

	    while((i++ < 3))
		ret += '=';
	}

	return ret;

    }

    std::string basic::base64_decode(std::string const& encoded_string) 
    {
	int in_len = encoded_string.size();
	int i = 0;
	int j = 0;
	int in_ = 0;
	unsigned char char_array_4[4], char_array_3[3];
	std::string ret;

	while (in_len-- && ( encoded_string[in_] != '=') && is_base64(encoded_string[in_])) 
	{
	    char_array_4[i++] = encoded_string[in_]; in_++;
	    if (i ==4) 
	    {
		for (i = 0; i <4; i++)
		    char_array_4[i] = consts::base64_chars.find(char_array_4[i]);

		char_array_3[0] = (char_array_4[0] << 2) + ((char_array_4[1] & 0x30) >> 4);
		char_array_3[1] = ((char_array_4[1] & 0xf) << 4) + ((char_array_4[2] & 0x3c) >> 2);
		char_array_3[2] = ((char_array_4[2] & 0x3) << 6) + char_array_4[3];

		for (i = 0; (i < 3); i++)
		    ret += char_array_3[i];
		i = 0;
	    }
	}

	if (i) 
	{
	    for (j = i; j <4; j++)
    		char_array_4[j] = 0;

	    for (j = 0; j <4; j++)
    		char_array_4[j] = consts::base64_chars.find(char_array_4[j]);

	    char_array_3[0] = (char_array_4[0] << 2) + ((char_array_4[1] & 0x30) >> 4);
	    char_array_3[1] = ((char_array_4[1] & 0xf) << 4) + ((char_array_4[2] & 0x3c) >> 2);
    	    char_array_3[2] = ((char_array_4[2] & 0x3) << 6) + char_array_4[3];

	    for (j = 0; (j < i - 1); j++)
		ret += char_array_3[j];
	}

	return ret;
    }

}
